﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication12
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ComboBoxItemsProvider statusProvider = this.xamDG.TryFindResource("StatusItemsProvider") as ComboBoxItemsProvider;
            if (statusProvider != null)
            {
                statusProvider.ItemsSource = new ComboBoxDataItem[]
                {
                    new ComboBoxDataItem(ProgressState.Ready, "Ready"),
                    new ComboBoxDataItem(ProgressState.InProgress, "In Progress"),
                    new ComboBoxDataItem(ProgressState.PendingCompletion, "Pending Completion"),
                    new ComboBoxDataItem(ProgressState.Complete, "Complete")
                };
            }

            base.DataContext = new Task[]
            {
                new Task
                {
                    Name="Deliver Payload",
                    State = ProgressState.Ready,
                    PriorityLevel = 0
                },
                new Task
                {
                    Name="Initialize Instruments",
                    State = ProgressState.Complete,
                    PriorityLevel = 2
                },
                new Task
                {
                    Name="Analyze Heat Sensor Log",
                    State = ProgressState.InProgress,
                    PriorityLevel = 2
                },
                new Task
                {
                    Name="Report Temperature Readings",
                    State = ProgressState.PendingCompletion,
                    PriorityLevel = 1
                }
            };
        }

        private void xamDG_CellChanged(object sender, Infragistics.Windows.DataPresenter.Events.CellChangedEventArgs e)
        {
            xamDG.ExecuteCommand(Infragistics.Windows.DataPresenter.DataPresenterCommands.EndEditModeAndDiscardChanges);
            CellValuePresenter cvp = CellValuePresenter.FromCell(e.Cell);


            ValueEditor editor = cvp.Editor;
            if (!editor.IsInEditMode)
            {
                editor.StartEditMode();
                ((XamComboEditor)e.Editor).SelectedIndex = 0;
                editor.Value = e.Editor.OriginalValue;
                editor.EndEditMode(true, false);
                // e.Handled = true;
            }

        }
    }

    public class Task
    {
        public string Name { get; set; }
        public int PriorityLevel { get; set; }
        public ProgressState State { get; set; }
    }

    public enum ProgressState
    {
        Complete,
        InProgress,
        PendingCompletion,
        Ready
    }
}
